
#ifdef WRITER
#define maxchar 40
#define maxline 10
#define DUREEPAUSE 60*4
// writer font
int CHAR_W2=8;
int CHAR_H2=8;
#include "font.h"

unsigned char* ptfont;

int textx,texty,lineptr=0,car=0; // writer et scroll simple

int WRITERSTARTX=0;
int WRITERSTARTY;//  = RASTERY1 + 2; // init dplace dans initWriter plus bas
int bufferw[maxchar*8*maxline*8];

int cx=0,cy=0;
int page=0;
int pause=0;
typedef unsigned char bool;
bool flagpause=FALSE;
bool flagerase=FALSE;
bool flagwrite=TRUE;
int posscrollv;// = RASTERY2 + 1; // init dplace dans initWriter plus bas
int poseraseh=0;
int poseraseh2=0;

char *lines[]={
	"                                        "
	"                  VRS!                  "
	"                                        "
	"              DONE TODAY :              "
	"                                        "
	"      TRSI DOUBLE TROUBLE CRACKTRO      "
	"              WIN32 REMAKE              "
	"                                        "
	"                                        "
	"                                        ",
	
	"                                        "
	"                                        "
	"                                        "
	"                                        "
	"                                        "
	"                                        "
	"                                        "
	"    INTRO MADE BY    DOUBLE TROUBLE     "
	"    MUSIC MADE BY              EMAX     "
	"                                        ",

	"                                        "
	"                                        "
	" CONTACT US FOR WHATEVER (NO SWAPPING)  "
	"                                        "
	"                                        "
	" POBOX 138 - 6460 NA KERKRADE - HOLLAND "
	"                                        "
	"                                        "
	"                                        "
	"                                        ",

	"                                        "
	" GREETINGS TO THOSE WHO DESERVES IT!    "
	"                                        "
	"     ANARCHY..BEERMACHT..KEFRENS        "
	"     PARADOX...DYNAMIX...SCOOPEX        "
	"     REBELS...QUADLITE...SILENTS        "
	"     SPREADPOINT...PMC...SUPPLEX        "
	"     SKIDROW...CRYSTAL....SANITY        "
	"                                        "
	"AND ALL TRUSTY TRSI BELIEVERS WORLDWIDE ",

	"                                        "
	"       TRISTAR - RED SECTOR 1993        "
	"                                        "
	"  ARE SEARCHING FOR NEW HQ`S WORLDWIDE  "
	"  ====================================  "
	"       LOOK OUT FOR TRSI MEMBERS        "
	"            TO CONTACT US !             "
	"       STAY TUNED - STAY FOREVER        "
	"        WE WILL NEVER SURRENDER!        "
	"                                        ",

	"                                        "
	"    SEE YA IN ANOTHER QUALITY RELEASE   "
	"     FROM THE TWO UNSTOPPABLE FORCES    "
	"                                        "
	"            WE`LL NEVER DIE!            "
	"                                        "
	"  BACK TO THE ROOTS...  (C) 1990-1993!  "
	"                                        "
	"    -- TRISTAR! AND RED SECTOR! --      "
	"      -- THE ONLY RIGHT WAY! --         ",
	NULL};

void initWriter()
{
	WRITERSTARTY = RASTERY1 + 2;
	posscrollv = RASTERY2 + 1;
}

// writer for message box
void writeletter(int x,int y,int ch,int clr)
{
	int sx,sy,offset;

	offset=ch*(CHAR_W2*CHAR_H2)-(CHAR_W2*CHAR_H2);

	for(sy=0;sy<CHAR_H2;sy++)
	{
		for(sx=0;sx<CHAR_W2;sx++)
		{
			if((x+sx)>=0 && (x+sx)<WIDTH/ZOOM && (y+sy)>=0 && (y+sy)<HEIGHT/ZOOM)
				if(*(ptfont+offset+sx+(sy*CHAR_W2))>0)
				{
					bufferw[x+sx+(y+sy)*maxchar*CHAR_W2]=clr;
				}
		}
	}
}
// clear old page
void Cls2(int rgb)
{
	int x;
	int y;
	//Do cls stuff
	for (y=0; y<maxline*CHAR_H2; y++)
	{
		for (x=0; x<maxchar*CHAR_W2; x++)
		{
            bufferw[(y*maxchar*CHAR_W2+x)] =rgb;
		}
	}
}

// write a new page
void Write(void)
{
	char *ptchar;

	Cls2(0);
	ptchar=lines[page];
	for(cy=0;cy<maxline;cy++)
	{
		for(cx=0;cx<maxchar;cx++)
		{
			car=*(ptchar+cx+cy*maxchar)-31;

			writeletter(cx*CHAR_W2,cy*CHAR_H2,car,RGB(255,255,255));
		}
	}
	flagwrite=FALSE;
}

// copy simple textbuffer on screen *Zoom
void CopyBuffer(int posx,int posy) // poseraseh,posscrollv
{
	int pixel,erase=0,txp=0,typ=0,ccx,posx2;

	for(cy=0;cy<maxline*CHAR_H2;cy++) // buffer d'origine
	{
		txp=0;
		ccx=0;
		posx2=posx;
		if(flagerase)
		{
			if(erase==0) erase=1; else ccx=poseraseh2,posx2=0,erase=0; 
		}
		// write the line
		for(cx=ccx;cx<(maxchar*CHAR_W2);cx++)
		{
			if((posx2+txp)>=0 && (posx2+txp)<WIDTH && (posy+typ)>=0 && (posy+typ)<RASTERY2-1)
			{
				pixel=bufferw[cx+cy*maxchar*CHAR_W2];
				if(pixel!=0)
				{
					buffer[posx2+txp+(posy+typ)*WIDTH]=pixel;
					if(ZOOM==2)
					{
						buffer[posx2+txp+1+(posy+typ)*WIDTH]=pixel;
						buffer[posx2+txp+1+(posy+typ+1)*WIDTH]=pixel;
						buffer[posx2+txp+(posy+typ+1)*WIDTH]=pixel;
					}
				}
			}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	}
}

void DoWriter(void)
{

	if(flagwrite) Write(); // new page

	CopyBuffer(poseraseh,posscrollv); // show current page

	// vertical scroll
	if(posscrollv>WRITERSTARTY)
	{
		posscrollv-=ZOOM;
	}else{
		// ok? pause
		if(!flagpause) pause=DUREEPAUSE, flagpause=TRUE;
	}

	// if pause
	if(flagpause)
	{
		pause--;
		// end of pause ?
		if(pause==0)
		{
			flagpause=FALSE;
			flagerase=TRUE; // scroll horizontal
		}
	}

	if(flagerase)
	{
		poseraseh+=4*ZOOM;
		poseraseh2+=4;
		if(poseraseh==320*ZOOM)
		{
			posscrollv=RASTERY2+1;
			flagpause=FALSE;
			// new page
			flagwrite=TRUE;
			page++;
			if(lines[page]==NULL) page=0;
			flagerase=FALSE;
			poseraseh=0;
			poseraseh2=0;
		}
	}
}
#endif

