// version FrameBuffer/tinyptc

// writer font
int CHAR_W2=8;
int CHAR_H2=11;
#include "../font1.h"
// sinus font
#include "../fontsin.h"
int CHAR_W=16;
int CHAR_H=16;
int sinadd;

int pause = 0;   
int flagpause=0;      
int affichelogo=0;

unsigned char* ptfont=font1;
unsigned char* ptfont2=font2;

int textx,texty,lineptr=0,car=0; // writer et scroll simple

unsigned int copperlist[480];    

unsigned int pal[49]={
0xFF77DD,0xEE666C,0xDD55BB,0xCC44AA,0xBB3399,0x991177,0x880066,0x770077,0x660088,0x550099,
0x4400aa,0x3300bb,0x2200cc,0x1100dd,0x0000ee,0x0011ee,0x0022ee,0x0033ee,0x0044ee,0x0055ee,
0x0066ee,0x2266ee,0x4466ee,0x6666ee,0x7777ee,0x8888ee,0x9999ee,0xaaaaee,0xbbbbee,0xbbbbee,
0xbbbbcc,0xbbbbaa,0xbbbb88,0xbbbb66,0xbbbb44,0xbbbb22,0xaaaa22,0x999922,0x888822,0x777722,
0x777744,0x777766,0x777788,0x7777aa,0x7777cc,0x9977cc,0xbb77cc,0xdd77cc,0xff77cc
}; 

int asinTbl[360];

// writer for message box
void writeletter(int x,int y,int ch,int clr)
{
	int sx,sy,offset,txp=0,typ=0;

	offset=ch*(CHAR_W2*CHAR_H2)-(CHAR_W2*CHAR_H2);

	for(sy=0;sy<CHAR_H2;sy++)
	{
		txp=0;
		for(sx=0;sx<CHAR_W2;sx++)
		{
			if((x+txp)>=0 && (x+txp)<WIDTH)
				if(*(ptfont+offset+sx+(sy*CHAR_W2))>0)
				{
					buffer[x+txp+(y+typ)*WIDTH]=clr;
					if(ZOOM==2)
					{
						buffer[x+txp+1+(y+typ)*WIDTH]=clr;
						buffer[x+txp+1+(y+typ+1)*WIDTH]=clr;
						buffer[x+txp+(y+typ+1)*WIDTH]=clr;
					}
				}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	}
}
float SINAMPL=39.5f;
float FREQ=0.01f;

// writer for sinuscroll
void writeletters(int x,int y,int ch,int clr)
{
	int sx,sy,offset,clr2;
	int txp=0,typ=0,sv;

	offset=ch*(CHAR_W*CHAR_H)-(CHAR_W*CHAR_H);

	for(sy=0;sy<CHAR_H;sy++)
	{
		txp=0;
		for(sx=0;sx<CHAR_W;sx++)
		{
//	        sv=(int)(40*ZOOM+SINAMPL*sin(((float)sinadd*PI/180+x+txp)*FREQ)); // sinus y pos
	        sv=(int)(40*ZOOM+asinTbl[(int)(((sinadd+x+txp)*0.5f))%360]); // sinus y pos

			if(((x+txp)>=0 && (x+txp)<WIDTH-1) && ((y+typ>0) && (y+typ<HEIGHT)))
			{
				if(*(ptfont2+offset+sx+(sy*CHAR_W))>0)
				{
					if(clr==0) clr2=copperlist[y+typ+sv]; else clr2=clr;
					buffer[x+txp+(y+typ+sv)*WIDTH]=clr2;
					if(ZOOM==2)
					{
						buffer[x+txp+1+(y+typ+sv)*WIDTH]=clr2;
						if(clr==0) clr2=copperlist[y+typ+sv+1]; else clr2=clr;
						buffer[x+txp+(y+typ+sv+1)*WIDTH]=clr2;
						buffer[x+txp+1+(y+typ+sv+1)*WIDTH]=clr2;
					}
				}
			}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	}
}

// -------------------------------------------- scrolltext horizontal simple (font1/2)
#ifdef SCROLLTXT
int scrollptr=0,scrollcount=0;

char scrtext[]="                        "
"- HORIZON -                abCRACKTRO REMAKE FOR DBFINTERACTIVE.COM !   "
"REMAKE BY VRS! - ORIGINAL CODE BY GASTON - MUSIC BY BLAIZER - LOGO BY STRIDER                     ";

char *ptscroll=scrtext;

int MP=0; 
int SCOFF=0;

void InitSinus(void)
{
	int i,b=0;
	float rad;

	for(i=0;i<HEIGHT;i++)
	{
		copperlist[i]=pal[b];
		b++;
		if(b==49) b=0;
	}


  /* create sin lookup table */
	for (i = 0; i < 360; i++)
	{
		rad =  (float)(i * PI/180); 
		asinTbl[i] =(int)(sin(rad)*SINAMPL);
	}
}


void DoScrollText(void)
{
	int i,car;
	sinadd+=5*ZOOM;
//	sinadd%=360;

	for(i=1;i<=33;i++)
	{
		if(*(ptscroll+i+MP)==97) affichelogo=1,i++;

		if(*(ptscroll+i+MP)==98 && flagpause==0)
		{
			pause=100;
			flagpause=1;
			i++;
		}

		if(*(ptscroll+i+MP)==98 && flagpause==1) i++;

		car=*(ptscroll+i+MP)-31;
		writeletters((i*(CHAR_W*ZOOM+1))-SCOFF,124*ZOOM,car,RGB(255,238,136));
		writeletters((i*(CHAR_W*ZOOM+1))-SCOFF,126*ZOOM,car,RGB(170,102,0));
		writeletters((i*(CHAR_W*ZOOM+1))-SCOFF,125*ZOOM,car,RGB(0,0,0));
	}

	if(pause>0) pause--;

	if(pause==0)
	{
	SCOFF+=3*ZOOM;
	if(SCOFF>=(32*ZOOM+1))
	{
		SCOFF-=17*ZOOM;
		MP++;
		if(*(ptscroll+MP+21)==0) MP=0;
//		if(MP>sizeof(scrtext)-21) MP=0;
	}
	}
}
#endif