#ifdef STARS2
#define NSTARS 60
float starx[NSTARS*4];
int stary[NSTARS*4];

void InitStars()
{
	int i;
	for(i=1;i<=NSTARS*4;i++)
	{
		starx[i]=(float)(rand()%WIDTH);
		stary[i]=(25*ZOOM+rand()%(HEIGHT-50*ZOOM+11*ZOOM))*WIDTH;
	}
}

void DrawStars()
{
	int i;
	for(i=1;i<=NSTARS;i++)
	{
		if(starx[i]<WIDTH && starx[i]>0) {
			buffer[(int)starx[i]+stary[i]]=0x2222cc;
			if(ZOOM==2){
				buffer[(int)starx[i]+1+stary[i]]=0x2222cc;
				buffer[(int)starx[i]+1+stary[i]+1]=0x2222cc;
				buffer[(int)starx[i]+stary[i]+1]=0x2222cc;
			}
		}
		starx[i]+=0.5f;
		if(starx[i]>WIDTH) starx[i]-=WIDTH;
	}
	for(i=1;i<=NSTARS*2;i++)
	{
		if(starx[i]<WIDTH && starx[i]>0) {
			buffer[(int)starx[i]+stary[i]]=0x4444dd;
			if(ZOOM==2){
				buffer[(int)starx[i]+1+stary[i]]=0x4444dd;
				buffer[(int)starx[i]+1+stary[i]+1]=0x4444dd;
				buffer[(int)starx[i]+stary[i]+1]=0x4444dd;
			}
		}
		starx[i]+=1.0f;
		if(starx[i]>WIDTH) starx[i]-=WIDTH;
	}
	for(i=1;i<=NSTARS*3;i++)
	{
		if(starx[i]<WIDTH && starx[i]>0) {
			buffer[(int)starx[i]+stary[i]]=0x7777ee;
			if(ZOOM==2){
				buffer[(int)starx[i]+1+stary[i]]=0x7777ee;
				buffer[(int)starx[i]+1+stary[i]+1]=0x7777ee;
				buffer[(int)starx[i]+stary[i]+1]=0x7777ee;
			}
		}
		starx[i]+=1.5f;
		if(starx[i]>WIDTH) starx[i]-=WIDTH;
	}
	for(i=1;i<=NSTARS*4;i++)
	{
		if(starx[i]<WIDTH && starx[i]>0 && stary[i]>=25*ZOOM*WIDTH) {
			buffer[(int)starx[i]+stary[i]]=0xaaaaff;
			if(ZOOM==2){
				buffer[(int)starx[i]+1+stary[i]]=0xaaaaff;
				buffer[(int)starx[i]+1+stary[i]+1]=0xaaaaff;
				buffer[(int)starx[i]+stary[i]+1]=0xaaaaff;
			}
		}
		starx[i]+=2.0f;
		if(starx[i]>WIDTH) starx[i]-=WIDTH;
	}
}
#endif