// version FrameBuffer/tinyptc


#include "FONT.H"	// font double
#include "mask.h"
#include "font1.h"	// font original
#include "mask1.h"

int CHAR_W2=16;
int CHAR_H2=12;

unsigned char* ptfont;
unsigned char* ptmask;

char tabchars2[]="abcdefghijklmnopqrstuvwxyz0123456789     !'"
	"'()+,-./:;<=>?   ";

int textx,texty,lineptr=0,car=0; // writer et scroll simple

// fonction qui trouve la position d'un caractre dans une font
int GetCharacter(char scrollchar, char *p)
{
	int pos=0;

	while((*p++ != scrollchar)&&(*p!=0)) pos++; // search char pos

	if(*p==0) pos=-1;
	return pos;
}

// write a letter with a mask
void writeletter2(int x,int y,int ch,int clr,int min,int max,int mk)
{
	int sx,sy,offset,offset2;

	offset=ch*(CHAR_W2*CHAR_H2);
	offset2=mk*(CHAR_W2*CHAR_W2);

	for(sx=0;sx<CHAR_W2;sx++)
		for(sy=0;sy<CHAR_H2;sy++)
			if((x+sx)>min && (x+sx)<max)
				if(*(ptmask+offset2+sx+sy*CHAR_W2)==1)
					if(*(ptfont+offset+sx+(sy*CHAR_W2))>0) 
						buffer[x+sx+(y+sy)*WIDTH]=clr;
}

// -------------------------------------------- scrolltext horizontal simple (font1/2)
#ifdef SCROLLTXT

#define NLETTERS 12
#define SCROLLWV NLETTERS*CHAR_W2
#define SCROLLW SCROLLWV
#define SCROLLH CHAR_H2
#define SCROLLX CHAR_W2*4
#define SCROLLY RASTERY2-CHAR_H2*2

float SPEEDSCROLL=1.5f;

int scrollptr=0,scrollcount=0;
char scrtext[]="              >skidrow remake< for 'dbfinteractive.com' contest "
	"for 'find a coder' facility of this community !   original scrolltext now. "
#ifndef ROBOCOD
	" moonfall from 21st century.    cracked by   >"
#else
	" robocod 2 final version from millenium.    cracked by   >"
#endif
	" f f c <  original supplied by    > s s r < and of course "
	"published through the leading force.  > skid row <    spec"
	"ial regards to the following cool people.   strider/fairli"
	"ght  -  hqc and skyline  -  onyx  -  afl  -  crystal  -  a"
	"gile  -  fred and rakim of vf  -  phil and randyran of the"
	" company!  -  legend!..    and to all the others ...   wat"
	"ch out for more and more stunning stuff from your favourit"
	"e group...>>> skid row <<<         later.  in another one."
	"            ";

char *ptscroll=scrtext;

int TabX[]={
	20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,
	19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,
	18,18,18,18,18,18,18,18,18,18,18,18,
	17,17,17,17,17,17,17,17,17,17,
	16,16,16,16,16,16,16,16,16,16,16,
	15,15,15,15,15,15,15,15,15,15,
	14,14,14,14,14,14,14,14,14,14,14,14,
	13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,
	12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,
	12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,
	13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,13,
	14,14,14,14,14,14,14,14,14,14,14,14,
	15,15,15,15,15,15,15,15,15,15,
	16,16,16,16,16,16,16,16,16,16,16,
	17,17,17,17,17,17,17,17,17,17,
	18,18,18,18,18,18,18,18,18,18,18,18,
	19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,
	20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20
};
int TabY[]={
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
	6,6,6,6,6,6,6,6,6,6,6,6,
	5,5,5,5,5,5,5,5,5,5,
	4,4,4,4,4,4,4,4,4,4,4,
	3,3,3,3,3,3,3,3,3,3,
	2,2,2,2,2,2,2,2,2,2,2,2,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	2,2,2,2,2,2,2,2,2,2,2,2,
	3,3,3,3,3,3,3,3,3,3,
	4,4,4,4,4,4,4,4,4,4,4,
	5,5,5,5,5,5,5,5,5,5,
	6,6,6,6,6,6,6,6,6,6,6,6,
	7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8
};

int pttabx=0,pttaby=0,pttabx2=128,pttaby2=128;
int go=0,gp=0;

void DoScrollText(void)
{
	int xpp,sc,car;

	go-=SPEEDSCROLL;
	if(go<-CHAR_W2)
	{
		go+=CHAR_W2;
		gp++;
		if(*(ptscroll+gp)==0) gp=0;
	}

	xpp=go;
	sc=0;

	while(xpp<SCROLLW)
	{
		sc++;
		if(*(ptscroll+sc+gp)==0) sc=0;

		car=GetCharacter(*(ptscroll+sc+gp),tabchars2);
		writeletter2(xpp+SCROLLX+TabX[pttabx]-8*ZOOM,SCROLLY+TabY[pttaby]-2*ZOOM,car,RGB(144,0,0),SCROLLX-8*ZOOM,SCROLLX+SCROLLW+8*ZOOM,0);
		writeletter2(xpp+SCROLLX+TabX[pttabx2]-8*ZOOM,SCROLLY+TabY[pttaby2],car,RGB(112,0,0),SCROLLX-8*ZOOM,SCROLLX+SCROLLW+8*ZOOM,0);
		writeletter2(xpp+SCROLLX,SCROLLY,car,RGB(255,0,0),SCROLLX,SCROLLX+SCROLLW,0);

		xpp+=CHAR_W2+1;
	}

	pttabx++;
	pttabx2++;
	pttaby+=2;
	pttaby2+=2;
	pttabx%=256;
	pttaby%=256;
	pttabx2%=256;
	pttaby2%=256;

}
#endif