// version FrameBuffer/tinyptc


#include "font_raw.h"

int CHAR_W2=728;
int CHAR_H2=46;

unsigned int* ptfont=font_raw;

//@=pause (2 sec) #+$ = scoopex
char tabchars2[]="ABCDEFGHIJKLMNOPQRSTUVWXYZ 1234567890#$.!'@";

unsigned char tabwidth[]={
	16,16,16,16,16,16,16,16,8,16,16,16,24,16,15,16,20,16,16,16,16,16,24,16,16,16,
	24,12,16,16,16,17,16,15,16,16,16,37,37,10,12,17,0,0,0,0
};

unsigned int tabpos[44];

int textx,texty,lineptr=0,car=0; // writer et scroll simple
// fonction qui trouve la position d'un caractre dans une font
int GetCharacter(char scrollchar, char *p)
{
	int pos=0;

	while((*p++ != scrollchar)&&(*p!=0)) pos++; // search char pos

	if(*p==0) pos=-1;
	return pos;
}

void initFont(void)
{
	int x,y,pixel,i,pos=0;
	for(i=0;i<43;i++)
	{
		tabpos[i]=pos;
		pos+=tabwidth[i];
	}

	for(y=0;y<CHAR_H2;y++)
	{
		for(x=0;x<CHAR_W2;x++)
		{
			pixel=*(ptfont+x+(y*CHAR_W2));
			*(ptfont+x+(y*CHAR_W2))=RGB((pixel>>16)&255,(pixel>>8)&255,(pixel)&255);
		}
	}
}

void writeletter(int x,int y,int ch)
{
	int sx,sy,w,txp=0,typ=0,offset,pixel;

	w=tabwidth[ch];
	offset=tabpos[ch];

	for(sy=0;sy<CHAR_H2;sy++)
	{
		txp=0;
		for(sx=0;sx<w;sx++)
		{
			if((x+txp)>=0 && (x+txp)<WIDTH-1)
			{
				pixel=*(ptfont+offset+sx+(sy*CHAR_W2));
				if(pixel>0)
				{
					buffer[x+txp+(y+typ)*WIDTH]=pixel;//RGB((pixel>>16)&255,(pixel>>8)&255,(pixel)&255);
					if(ZOOM==2)
					{
						buffer[x+txp+(y+typ+1)*WIDTH]=pixel;//RGB((pixel>>16)&255,(pixel>>8)&255,(pixel)&255);
						buffer[x+txp+1+(y+typ+1)*WIDTH]=pixel;//RGB((pixel>>16)&255,(pixel>>8)&255,(pixel)&255);
						buffer[x+txp+1+(y+typ)*WIDTH]=pixel;//RGB((pixel>>16)&255,(pixel>>8)&255,(pixel)&255);
					}
				}
			}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	}
}

int GRDSTARTX=0;
int GRDSTARTY=44;
int SIZEGRADX=320;
int SIZEGRADY=126;

col palette[]={ // 
0,0,0x11,0,0,0x11,0,0,0x11,0,0,0x11,0,0,0x11,0,0,0x22,0,0,0x22,0,0,0x22,0,0,0x22,0,0,0x22,
0,0,0x33,0,0,0x33,0,0,0x33,0,0,0x33,0,0,0x33,0,0,0x44,0,0,0x44,0,0,0x44,0,0,0x44,0,0,0x55,
0,0,0x55,0,0,0x55,0,0,0x55,0,0,0x66,0,0,0x66,0,0,0x66,0,0,0x66,0,0,0x77,0,0,0x77,0,0,0x77,
0,0,0x88,0,0,0x88,0,0,0x88,0,0,0x99,0,0,0x99,0,0,0x99,0,0,0xaa,0,0,0xaa,0,0,0xbb,0,0,0xbb,
0,0,0xcc,0,0,0xdd,0,0,0xee,0,0,0xff,0,0x11,0xff,0,0x22,0xff,0,0x33,0xff,0,0x44,0xff,0,0x55,0xff,0,0x66,0xff,
0,0x77,0xff,0,0x88,0xff,0,0x99,0xff,0,0xaa,0xff,0,0xbb,0xff,0,0xcc,0xff,0,0xdd,0xff,0,0xee,0xff,0,0xff,0xff,0,0xff,0xff,
0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,
0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,
//0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,0,0xff,0xff,
136,136,136,119,119,119,0,0x99,0x99,0,0x88,0x88,0,0x88,0x88,0,0x77,0x88,0,0x77,0x88,0,0x66,0x88,0,0x66,0x88,0,0x55,0x88,
0,0x55,0x88,0,0x44,0x88,0,0x44,0x88,0,0x33,0x88,0,0x33,0x88,0,0x22,0x88,0,0x22,0x88,0,0x11,0x88,0,0x11,0x88,0,0,0x88,
0,0,0x88,0,0,0x77,0,0,0x77,0,0,0x66,0,0,0x66,0,0,0x55,0,0,0x55,0,0,0x55,0,0,0x44,0,0,0x44,
0,0,0x44,0,0,0x33,0,0,0x33,0,0,0x33,0,0,0x22,0,0,0x22,0,0,0x22,0,0,0x11,0,0,0x11,0,0,0x11,
0,0,0x11,0,0,0x11,0,0,0x11,0,0,0x11,0,0,0x11,0,0,0x11
};

void DoGradient(void)
{
	int cx,cy,txp=0,typ=0,col;

	for(cy=0;cy<SIZEGRADY;cy++)
	{
		txp=0;
		for(cx=0;cx<SIZEGRADX;cx++)
		{
			if(buffer[txp+GRDSTARTX+(typ+GRDSTARTY)*WIDTH]==RGB(0,0,0))
			{
				col=RGB(palette[(int)cy].b,palette[(int)cy].g,palette[(int)cy].r);
				buffer[txp+GRDSTARTX+(typ+GRDSTARTY)*WIDTH]=col;
				if(ZOOM==2)
				{
					buffer[txp+GRDSTARTX+(typ+1+GRDSTARTY)*WIDTH]=col;
					buffer[txp+1+GRDSTARTX+(typ+1+GRDSTARTY)*WIDTH]=col;
					buffer[txp+1+GRDSTARTX+(typ+GRDSTARTY)*WIDTH]=col;
				}
			}
			txp+=ZOOM;
		}
		typ+=ZOOM;
	}

}
// -------------------------------------------- scrolltext horizontal simple (font1/2)
#ifdef SCROLLTXT

int SCROLLW=320;
int SCROLLY=125+10+13+2; //-CHAR_H2/2
float SPEEDSCROLL=2.5f;
float scrollcount=0.0f;

int scrollptr=0,curw=0;
int pause=0;
typedef unsigned char bool;
#define false FALSE
#define true TRUE
bool flagpause=false;

char scrtext[]=
	"                  VRS! PRESENTS    #$ INTRO   @ WINDOWS REMAKE IN APR 2007 ! "
	"ORIGINAL SCROLL....     HMMM THIS TIME IT WAS A HARD CRACK ....'CAUSE"
	" THE WHOLE LOADING ROUTINES WERE WRITTEN IN FUCKING C-CODE"
	" AND THE ORIGINAL HAD SEVERAL READ ERRORS ...          SOR"
	"RY FOR NO MEGATRAINING BUT I WANT TO FINISH THE #$ MEGACRU"
	"NCHER AND I'VE ABSOLUTELY NO TIME FOR TRAINING GAMES"
	" !!!         CALL OUR WHQ     INVOLUNTARY DEATH   @ON     "
	"  7O8 599 1537    @   TO GET OUR LATEST WAREZ WRITE TO : "
	"      PO.BOX 6O     @   4O6O LEONDING   @      AUSTRIA  "
	"   @    TO GET IN TOUCH WITH OUR SYSOP WRITE TO :    PO.B"
	"OX 2221    @  BRIDGEVIEW     @  IL 6O455 USA    @  ......."
	".   WELL , OUR MEMBERLIST WENT DOWN A LITTLE BIT CAUSE THE"
	"RE ARE NO LONGER SECTIONS IN ...... ENGLAND AND SWEDEN !!!"
	"!   HERE'S A SMALL LIST INCLUDING THE PEOPLE WHO LEF"
	"T SCOOPEX TO START THEIR CARRIER IN ANOTHER GROUP : PENNYW"
	"ISE .. UNCLE TOM .. JESUS .. ZARK .. - ALL IN SHARE AND EN"
	"JOY .. MERRYMAN AND PANTHER !!!!     I WISH YA GOOD LUCK W"
	"HERE EVER YOU ARE !!!        ALSO OUR DIVISION IN GERMANY "
	"WAS BUSTED , 'CAUSE SOME PEOPLE THOUGHT THEY COULD R"
	"ELEASE EVERY SHIT LIKE THEIR 'MEGADEMO'  ALTOUGH WE BUSTED"
	" #$ GERMANY OUT , THEY RELEASED THEIR MEGADEMO!!!     SO T"
	"HIS MEGADEMO IS NO #$ PRODUCTION !!!      I WANT TO SMASH "
	"SOME HELLOS TO OUR FRIENDS ...... SUBWAY .. FAIRLIGHT .. P"
	"IRANHAS .. QUARTEX .. RED SECTOR .. QUICKSILVER .. THRUST "
	".. M.A.D .. SHARE AND ENJOY .. SPREADPOINT .. ORACLE .. DO"
	"PE .. VISION FACTORY AND ALL OTHERS WHICH ARE WORTH TO BE "
	"MENTIONED !!!!          SPECIAL NOTE : THE GAME CRASHED SO"
	"METIMES DURING LOADING ...      BUT WE FIXED (OF COURSE) T"
	"HIS FAULT !!!             WAIT 4 MORE UPCOMING RELEASES FR"
	"OM SCOOPEX .........           SIGNED CHALLENGER  15.2.199"
	"0          END OF LINE !!!   @    #$ GENERATIONS AHEAD @"
	"!!!                     "
	"                          ";

char *ptscroll=scrtext;

void DoScrollText(void)
{
	int xpp,sc,car;

	if(pause>0) pause--;

	if(pause==0)
	{
		scrollcount-=SPEEDSCROLL;

		if(scrollcount<-curw)
		{
			scrollcount=0;
			ptscroll++;
			if(*(ptscroll)==64) ptscroll++;
			if(*(ptscroll)==0) ptscroll=scrtext;
			car=GetCharacter(*(ptscroll+1),tabchars2);
			if(car==-1) car=26;
			curw=tabwidth[car]*ZOOM;
		}
	}
	
	xpp=scrollcount;
	sc=0;
	while(xpp<SCROLLW)	// write line from new char
	{
		sc++;
		if(*(ptscroll+sc)==0) sc=0,ptscroll=scrtext;

		car=GetCharacter(*(ptscroll+sc),tabchars2);
		if(car==-1) car=26;
		if(*(ptscroll+sc)!=64) writeletter(xpp,SCROLLY,car),xpp+=tabwidth[car]*ZOOM;
			else if(!flagpause) pause=100,flagpause=true;
	}

}
#endif
//--------------------------------------------------------- mountains
#ifdef PARALLAX
#include "moutains_raw.h"

unsigned char mount_raw[640*2*156];

unsigned char* pt_mount=mount_raw;

int PARWIDTH=640*2;
int PARVWIDTH=320;
int PARHEIGHT=26;
int PARSTARTY=70+9;
int MPARSTARTY=125;//PARSTARTY+PARHEIGHT+2;

int pscrollx[]={
	0,0,0,0,0,0
};

unsigned char vscrollx[]={
	6,5,4,3,2,1
};

unsigned int parposy[]={
	20,16,12,8,4,0
};
// palettes
unsigned char collayer[]={
	//144,128,112,96,80,64
	0x99,0x88,0x77,0x66,0x55,0x44
};
// mirror
unsigned char collayerm[]={
	102,85,68,51,34,17
};

void initParallax(void)
{
	unsigned int x,y;

	for(y=0;y<156;y++)
	{
		for(x=0;x<640;x++)
		{
			mount_raw[x+y*640*2]=mountains_raw[x+y*640];
			mount_raw[640+x+y*640*2]=mountains_raw[x+y*640];
		}
	}

}

void DoParallax(void)
{
	int l,x,y,pixel,txp=0,typ=0,typ2=0;
	// each layer
	for(l=5;l>=0;l--)
	{
		// each line
		typ=0;
		typ2=0;
		for(y=0;y<PARHEIGHT;y++)
		{
			// width
			txp=0;
			for(x=0;x<PARVWIDTH;x++)
			{
				pixel=*(pt_mount+l*(PARWIDTH*PARHEIGHT)+pscrollx[l]+x+y*PARWIDTH);
				if(pixel!=0)
				{
					buffer[txp+(PARSTARTY+parposy[l]*ZOOM+typ)*WIDTH]=RGB(collayer[l],collayer[l],collayer[l]);
					if(ZOOM==2)
					{
						buffer[1+txp+(PARSTARTY+parposy[l]*ZOOM+typ+1)*WIDTH]=RGB(collayer[l],collayer[l],collayer[l]);
						buffer[txp+(PARSTARTY+parposy[l]*ZOOM+typ+1)*WIDTH]=RGB(collayer[l],collayer[l],collayer[l]);
						buffer[1+txp+(PARSTARTY+parposy[l]*ZOOM+typ)*WIDTH]=RGB(collayer[l],collayer[l],collayer[l]);
					}
				}

				// mirror
				if(typ2<=PARHEIGHT)
					pixel=*(pt_mount+l*(PARWIDTH*PARHEIGHT)+pscrollx[l]+x+(PARHEIGHT-typ2)*PARWIDTH);
				else pixel=0;
				if(pixel!=0)
				{
					buffer[txp+(MPARSTARTY+(parposy[5-l]*ZOOM)/2+typ)*WIDTH]=RGB(collayerm[l],collayerm[l],collayerm[l]);
					if(ZOOM==2)
					{
						buffer[1+txp+(MPARSTARTY+(parposy[5-l]*ZOOM)/2+typ+1)*WIDTH]=RGB(collayerm[l],collayerm[l],collayerm[l]);
						buffer[txp+(MPARSTARTY+(parposy[5-l]*ZOOM)/2+typ+1)*WIDTH]=RGB(collayerm[l],collayerm[l],collayerm[l]);
						buffer[1+txp+(MPARSTARTY+(parposy[5-l]*ZOOM)/2+typ)*WIDTH]=RGB(collayerm[l],collayerm[l],collayerm[l]);
					}
				}
	
				txp+=ZOOM;
			}
			typ+=ZOOM;
			typ2+=2;
		}

		pscrollx[l]+=vscrollx[l];
		if(pscrollx[l]>640) pscrollx[l]=0;
	}

}
#endif